//
//  DIYDownMenu.m
//  DIYCalendar
//
//  Created by Apple on 17/3/13.
//  Copyright © 2017年 手握日月摘星辰，世间无我这般人. All rights reserved.
//

#import "DIYDownMenu.h"

@interface DIYDownMenu ()<UITableViewDelegate,UITableViewDataSource,SelectedDelegate>

#pragma mark－－－－－－－－－－视图
/**底部视图**/
@property(strong,nonatomic) UIView *bottomView;
/**下拉视图**/
@property(strong,nonatomic) UITableView *hyTableview;

#pragma mark－－－－－－－－－－数据
/**菜单个数**/
@property(assign,nonatomic) NSInteger menuNumber;

/**当前的是第几个菜单**/
@property(assign,nonatomic) NSInteger currentMenu;

/**姓名数组**/
@property(strong,nonatomic) NSArray *titleArray;

/**总体的数据**/
@property(strong,nonatomic) NSArray *totalArray;

/**具体数据数组**/
@property(strong,nonatomic) NSArray *dataArray;

@end


@implementation DIYDownMenu
-(instancetype)initWithFrame:(CGRect)frame
{
    if (self=[super initWithFrame:frame]) {
        
        [self createMainView:frame];
    }
    return self;
}

#pragma mark－－－－－－－－－－创建视图－－－－－－－－－－
-(void)createMainView:(CGRect)frame
{
    self.bottomView=[[UIView alloc]initWithFrame:CGRectMake(0,0,frame.size.width,frame.size.height)];
    self.bottomView.layer.borderWidth=0.5;
    self.bottomView.layer.borderColor=[UIColor lightGrayColor].CGColor;
    [self addSubview:self.bottomView];
    
    CGFloat menuWidth=UIScreen_Width/3;
    
    UIView *firstLineView=[[UIView alloc]initWithFrame:CGRectMake(menuWidth-0.25,0,0.5,frame.size.height)];
    firstLineView.backgroundColor=[UIColor lightGrayColor];
    [self addSubview:firstLineView];
    
    UIView *secondLineView=[[UIView alloc]initWithFrame:CGRectMake(menuWidth*2-0.25,0,0.5,frame.size.height)];
    secondLineView.backgroundColor=[UIColor lightGrayColor];
    [self addSubview:secondLineView];
    
    self.firstMenu=[[BaseView1 alloc]initWithFrame:CGRectMake(0,0,menuWidth-0.25,frame.size.height)];
    self.firstMenu.delegate=self;
    [self.bottomView addSubview:self.firstMenu];
    
    self.secondMenu=[[BaseView1 alloc]initWithFrame:CGRectMake(menuWidth+0.5,0,menuWidth-0.25,frame.size.height)];
    self.secondMenu.delegate=self;
    [self.bottomView addSubview:self.secondMenu];
    
    self.thirdMenu=[[BaseView1 alloc]initWithFrame:CGRectMake(menuWidth*2+1,0,menuWidth-0.25,frame.size.height)];
    self.thirdMenu.delegate=self;
    [self.bottomView addSubview:self.thirdMenu];
    
}


#pragma mark－－－－－－－－－－请求数据－－－－－－－－－－
-(void)reloadData
{
    if ([self.delegate respondsToSelector:@selector(numberOfMenu:)]) {
        self.menuNumber=[self.delegate numberOfMenu:self];
    }
    if ([self.delegate respondsToSelector:@selector(titleForMenu:)]) {
        self.titleArray=[self.delegate titleForMenu:self];
    }
    if ([self.delegate respondsToSelector:@selector(numberOfRowInMenum:)]) {
        self.totalArray=[self.delegate numberOfRowInMenum:self];
    }
    
    [self refreshView];
}

-(void)refreshView
{
    self.firstMenu.titleLabel.text=[self.titleArray firstObject];
    self.secondMenu.titleLabel.text=[self.titleArray objectAtIndex:1];
    self.thirdMenu.titleLabel.text=[self.titleArray lastObject];
}

#pragma mark－－－－－－－－－－设置代理－－－－－－－－－－

#pragma mark－－－－－UITableViewDelegate&&UITableViewDataSource
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.dataArray.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *cellId=@"TestDownMenu";
    UITableViewCell *cell=[tableView dequeueReusableCellWithIdentifier:cellId];
    if (!cell) {
        cell=[[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellId];
    }
    cell.textLabel.text=self.dataArray[indexPath.row];
    cell.textLabel.textColor=[UIColor lightGrayColor];
    cell.textLabel.font=[UIFont systemFontOfSize:14];
    cell.textLabel.textAlignment=NSTextAlignmentCenter;
    return cell;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 40;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSString *newTitle=[self.dataArray objectAtIndex:indexPath.row];
    [self.delegate userSelectedRow:newTitle];
    if (self.currentMenu==1) {
        self.firstMenu.titleLabel.text=newTitle;
        self.firstMenu.IndicateView.transform=CGAffineTransformIdentity;
    }else if (self.currentMenu==2){
        self.secondMenu.titleLabel.text=newTitle;
        self.secondMenu.IndicateView.transform=CGAffineTransformIdentity;
    }else{
        self.thirdMenu.titleLabel.text=newTitle;
        self.thirdMenu.IndicateView.transform=CGAffineTransformIdentity;
    }
    self.hyTableview.hidden=YES;
}

#pragma mark－－－－－SelectedDelegate(点击菜单时的操作)
-(void)sendSelectedState:(BOOL)hasSelected andTitle:(NSString *)currentTitle
{
    CGFloat tableviewWidth=UIScreen_Width/3;
    UIView *supperView=[self superview];
    hasSelected=YES;
    if (!self.hyTableview) {
        self.hyTableview=[[UITableView alloc]initWithFrame:CGRectMake(0,0,tableviewWidth,0) style:UITableViewStylePlain];
        self.hyTableview.delegate=self;
        self.hyTableview.dataSource=self;
        self.hyTableview.layer.borderWidth=0.5;
        self.hyTableview.layer.borderColor=[UIColor lightGrayColor].CGColor;
        [supperView addSubview:self.hyTableview];
    }
    self.hyTableview.hidden=NO;
    if ([currentTitle isEqualToString:self.firstMenu.titleLabel.text]) {
        self.dataArray=[self.totalArray firstObject];
        self.firstMenu.IndicateView.transform=CGAffineTransformMakeRotation(M_PI);
        self.currentMenu=1;
        if (hasSelected) {
            self.hyTableview.frame=CGRectMake(0,self.bottomView.frame.size.height+64,tableviewWidth,40*self.dataArray.count);
            [self.hyTableview reloadData];
        }else{
            self.hyTableview.frame=CGRectMake(0,self.bottomView.frame.size.height+64,tableviewWidth,0);
        }
    }else if ([currentTitle isEqualToString:self.secondMenu.titleLabel.text]){
        self.dataArray=[self.totalArray objectAtIndex:1];
        self.secondMenu.IndicateView.transform=CGAffineTransformMakeRotation(M_PI);
        if (self.currentMenu==2) {
            self.hyTableview.hidden=YES;
        }
        self.currentMenu=2;
        if (hasSelected) {
            self.hyTableview.frame=CGRectMake(tableviewWidth,self.bottomView.frame.size.height+64,tableviewWidth,40*self.dataArray.count);
            [self.hyTableview reloadData];
        }else{
            self.hyTableview.frame=CGRectMake(0,self.bottomView.frame.size.height+64,tableviewWidth,0);
        }
    }else{
        self.dataArray=[self.totalArray lastObject];
        self.thirdMenu.IndicateView.transform=CGAffineTransformMakeRotation(M_PI);
        self.currentMenu=3;
        if (hasSelected) {
            self.hyTableview.frame=CGRectMake(tableviewWidth*2,self.bottomView.frame.size.height+64,tableviewWidth,40*self.dataArray.count);
            [self.hyTableview reloadData];
        }else{
            self.hyTableview.frame=CGRectMake(0,self.bottomView.frame.size.height+64,tableviewWidth,0);
        }
    }
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
