//
//  ShowViewController.m
//  DIYCalendar
//
//  Created by Apple on 17/3/13.
//  Copyright © 2017年 手握日月摘星辰，世间无我这般人. All rights reserved.
//

#import "ShowViewController.h"

@interface ShowViewController ()<DIYDownMenuDelegate>

#pragma mark－－－－－－－－－－视图
@property(strong,nonatomic) DIYDownMenu *hyMenu;


#pragma mark－－－－－－－－－－数据
/**菜单数据**/
@property(strong,nonatomic) NSMutableArray *hyDataArray;




@end

@implementation ShowViewController

-(void)viewWillAppear:(BOOL)animated
{
    self.automaticallyAdjustsScrollViewInsets=NO;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor=[UIColor whiteColor];
    self.title=@"展示视图";
    
    //初始化工具
    [self initTool];
    
    //请求数据
    [self requestData];
    //创建视图
    [self createMainView];
    
    //左视图
    [self createLeftItem];
}

#pragma mark－－－－－－－－－－初始化－－－－－－－－－－
-(void)initTool
{
    self.hyDataArray=[NSMutableArray arrayWithCapacity:0];
}

#pragma mark－－－－－－－－－－创建视图－－－－－－－－－－
//左视图
-(void)createLeftItem
{
    UIButton *leftBtn  = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, 50, 44)];
    [leftBtn setTitle:@"< 返回" forState:UIControlStateNormal];
    leftBtn.titleLabel.font = [UIFont systemFontOfSize:16];
    [leftBtn setTitleColor:[UIColor blueColor] forState:UIControlStateNormal];
    [leftBtn addTarget:self action:@selector(gotoBack) forControlEvents:UIControlEventTouchUpInside];
    
    UIBarButtonItem *leftItem = [[UIBarButtonItem alloc] initWithCustomView:leftBtn];
    self.navigationItem.leftBarButtonItem = leftItem;
}

//主视图
-(void)createMainView
{
    self.hyMenu=[[DIYDownMenu alloc]initWithFrame:CGRectMake(0,64,UIScreen_Width,40)];
    self.hyMenu.delegate=self;
    [self.hyMenu reloadData];
    [self.view addSubview:self.hyMenu];
}

#pragma mark－－－－－－－－－－获取数据－－－－－－－－－－
-(void)requestData
{
    NSArray *nameArray=[NSArray arrayWithObjects:@"张玉善",@"张堂善",@"张满善",@"张臻善",@"张宏善",@"张磊善",nil];
    NSArray *sexArray=[NSArray arrayWithObjects:@"男",@"女",@"男男",@"女女",@"双性",nil];
    NSArray *ageArray=[NSArray arrayWithObjects:@"38",@"36",@"28",@"28",@"27",@"26",nil];
    [self.hyDataArray addObject:nameArray];
    [self.hyDataArray addObject:sexArray];
    [self.hyDataArray addObject:ageArray];
}

#pragma mark－－－－－－－－－－设置代理－－－－－－－－－－

-(NSInteger)numberOfMenu:(DIYDownMenu *)menu
{
    return 3;
}

-(NSArray *)titleForMenu:(DIYDownMenu *)menu
{
    return @[@"姓名",@"性别",@"年龄"];
}


-(NSArray *)numberOfRowInMenum:(DIYDownMenu *)menu
{
    return self.hyDataArray;
}

-(void)userSelectedRow:(NSString *)selectedText
{
    NSLog(@"点击的数据是%@",selectedText);
}

#pragma mark－－－－－－－－－－用户交互－－－－－－－－－－
//返回
-(void)gotoBack
{
    [self.navigationController popViewControllerAnimated:YES];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
